/* */
SELECT *
FROM employee


/* */
SELECT fname, lname, emp_id
FROM employee

/* */
SELECT emp_id, lname, fname
FROM employee

/* */
SELECT EmployeeID = emp_id, LastName = lname, FirstName = fname
FROM employee

/* */
SELECT emp_id AS EmployeeID,  lname AS LastName,  fname AS FirstName
FROM employee

/* */
SELECT fname, lname, 'Employee ID:', emp_id
FROM employee


/* */
SELECT lname + ', ' + SUBSTRING(fname,1,1) + '.'
AS Name, emp_id as EmployeeID
FROM employee

/* */
SELECT emp_id AS EmployeeID,  lname + ', ' + SUBSTRING(fname,1,1) +
'.' AS Name, 'Has been employed for ', 
DATEDIFF(year, hire_date, getdate()), ' years.' 
FROM employee

/* */
SELECT COL_NAME(OBJECT_ID('employee'),2)

/* */
SELECT CONVERT(CHAR(8),GETDATE(),2)


SELECT emp_id AS EmployeeID,  lname + ', ' + SUBSTRING(fname,1,1) + '.'
AS Name, 'Has been employed for ' + CONVERT(CHAR(2),
(DATEDIFF(year, hire_date, getdate()))) + ' years.'
FROM employee

/* */
SELECT emp_id, lname, fname
FROM employee
WHERE pub_id = '0877'

/* */
SELECT lname, emp_id
FROM employee
WHERE hire_date BETWEEN '10/1/92' AND '12/31/92'

/* */
SELECT emp_id, lname, fname
FROM employee
WHERE pub_id IN ('0877', '9999')

/* */
SELECT emp_id, lname, fname
FROM employee
WHERE pub_id NOT IN ('0877', '9999')

/* */
SELECT title_id, title
FROM titles
WHERE  title LIKE '%computer%'

/* */
SELECT au_id, au_lname, au_fname
FROM authors
WHERE au_lname LIKE '[BM]%'


/* */
SELECT title_id, title
FROM titles
WHERE ytd_sales IS NULL

/* */
SELECT title_id, title
FROM titles
WHERE ytd_sales IS NOT NULL

/* */
SELECT title_id, title, price, pub_id
FROM titles
WHERE title LIKE '%computer%' OR pub_id  = '0877' AND price IS NOT NULL

/* */
SELECT title_id, title, price, pub_id
FROM titles
WHERE (title LIKE '%computer%' OR pub_id  = '0877') AND price IS NOT NULL

/* */
SELECT DISTINCT city, state
FROM authors

/* */
SELECT title_id, au_id
FROM titleauthors
ORDER BY title_id, au_id

/* */
SELECT title_id, au_id
FROM titleauthors
ORDER BY 1, 2

/* */
SELECT COUNT(*)
FROM employee

/* */
SELECT MAX(ytd_sales)
FROM titles

/* */
SELECT SUM(qty)
FROM sales

/* */
SELECT title_id, count(title_id) AS Number_of_Authors
FROM titleauthor
GROUP BY title_id
HAVING count(title_id) > 1

/* */
SELECT title_id, ytd_sales
FROM titles
WHERE (ytd_sales>=4000)
GROUP BY ALL title_id, ytd_sales

/* */
SELECT type, SUM(ytd_sales)
FROM titles
GROUP BY type

/* */
SELECT type, ytd_sales
FROM titles
ORDER BY type
COMPUTE SUM(ytd_sales) BY type

/* */
SELECT type, pub_id,
SUM(ytd_sales) AS ytd_sales
FROM titles
GROUP BY type, pub_id
WITH ROLLUP

/* */
SELECT type, pub_id,
SUM(ytd_sales) AS ytd_sales
FROM titles
GROUP BY type, pub_id
WITH CUBE

/* */
SELECT pub_id, pub_name, pr_info
FROM publishers, pub_info
WHERE publishers.pub_id = pub_info.pub_id

/* */
SELECT pub_id, pub_name, pr_info
FROM publishers
INNER JOIN pub_info ON publishers.pub_id = pub_info.pub_id


/* */
SELECT publishers.*, pub_info.logo, pub_info.pr_info
FROM publishers, pub_info
WHERE publishers.pub_id = pub_info.pub_id

/* */
SELECT publishers.*, pub_info.logo, pub_info.pr_info
FROM publishers
INNER JOIN pub_info ON publishers.pub_id = pub_info.pub_id

/* */
SELECT titles.title, titleauthor.au_id
FROM titles, titleauthor

/* */
SELECT titles.title, titleauthor.au_id
FROM titles CROSS JOIN titleauthor

/* */
SELECT titles.title_id, titles.title, sales.qty
FROM titles LEFT OUTER JOIN sales
ON titles.title_id = sales.title_id

/* */
SELECT au1.au_fname, au1.au_lname,
au2.au_fname, au2.au_lname,
au1.city, au1.zip
FROM authors au1, authors au2
WHERE au1.city = au2.city
AND au1.zip = au2.zip
AND au1.au_id < au2.au_id
ORDER BY au1.city, au1.zip

/* */
SELECT au1.au_fname, au1.au_lname,
au2.au_fname, au2.au_lname,
au1.city, au1.zip
FROM authors au1
INNER JOIN authors au2 ON au1.city = au2.city
AND au1.zip = au2.zip
WHERE au1.au_id < au2.au_id
ORDER BY au1.city, au1.zip

/* */
SELECT DISTINCT au_fname, au_lname, state
FROM authors
WHERE state IN
(SELECT state FROM stores)

/* */
SELECT DISTINCT au_fname, au_lname, state
FROM authors
WHERE EXISTS
(SELECT * FROM stores
WHERE state = authors.state)

/* */
SELECT au1.au_fname, au1.au_lname,
au2.au_fname, au2.au_lname,
au1.city, au1.zip
FROM authors au1, authors au2
WHERE au1.city = au2.city
AND au1.zip = au2.zip
AND au1.au_id < au2.au_id
ORDER BY au1.city, au1.zip

/* */
SELECT au1.au_fname, au1.au_lname, au1.city, au1.zip
FROM authors au1
WHERE zip IN
(SELECT zip
FROM authors au2
WHERE au1.city = au2.city
AND au1.au_id <> au2.au_id)
ORDER BY au1.city, au1.zip

/* */
SELECT title_id, title, price
INTO #tmpTitles
FROM titles
GO
SELECT * FROM #tmpTitles
GO

/* */
SELECT title, stor_name, ord_date, qty
FROM titles, sales, stores
WHERE titles.title_id = sales.title_id
AND stores.stor_id = sales.stor_id
UNION
SELECT title, 'No Sales', NULL, NULL
FROM titles
WHERE title_id NOT IN
(SELECT title_id FROM sales)
ORDER BY qty
